commit cf172d0cdf355042223a3b1ebc04b472386a954e
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Thu Sep 15 22:39:24 2022 +0200

    Fortran: catch NULL pointer dereferences while simplifying PACK [PR106857]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/106857
            * simplify.c (gfc_simplify_pack): Check for NULL pointer dereferences
            while walking through constructors (error recovery).
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/106857
            * gfortran.dg/pr106857.f90: New test.
    
    (cherry picked from commit 2b75d5f533b9d6b39f4055949aff64ed0d22dd24)

diff --git a/gcc/fortran/simplify.c b/gcc/fortran/simplify.c
index 29d4c695302..b3d73935771 100644
--- a/gcc/fortran/simplify.c
+++ b/gcc/fortran/simplify.c
@@ -6293,7 +6293,7 @@ gfc_simplify_pack (gfc_expr *array, gfc_expr *mask, gfc_expr *vector)
       /* Copy only those elements of ARRAY to RESULT whose
 	 MASK equals .TRUE..  */
       mask_ctor = gfc_constructor_first (mask->value.constructor);
-      while (mask_ctor)
+      while (mask_ctor && array_ctor)
 	{
 	  if (mask_ctor->expr->value.logical)
 	    {
diff --git a/gcc/testsuite/gfortran.dg/pr106857.f90 b/gcc/testsuite/gfortran.dg/pr106857.f90
new file mode 100644
index 00000000000..4b0f86a75a6
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr106857.f90
@@ -0,0 +1,12 @@
+! { dg-do compile }
+! PR fortran/106857 - ICE in gfc_simplify_pack
+! Contributed by G.Steinmetz
+
+program p
+  type t
+     integer :: n
+  end type
+  type(t), parameter :: a(2,2) = t(1)
+  type(t), parameter :: b(4) = reshape(a, [2])                          ! { dg-error "Different shape" }
+  type(t), parameter :: c(2) = pack(b, [.false.,.true.,.false.,.true.]) ! { dg-error "Different shape" }
+end

